/**
  ******************************************************************************
  * @file    vk1072b.c
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   This file contains all the vk1072b functions. 
	*          ļ VK1072b
  ******************************************************************************
  * @attention
  ******************************************************************************
  */	
/* Includes ------------------------------------------------------------------*/
#include "vk1072b.h"
  
/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define VK1072b_CLK 10 //WRźƵ,delay_nusʵ 50->10kHz 10->50kHz 5->100kHz
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
//segtab[]ӦʵʵоƬLCDߣ߼-VK1072bο·
unsigned char vk1072b_segtab[VK1072b_SEGNUM]={
	0,2,4,6,8,10,12,14,15,			//SEG0-SEG15
	16,18,20,22,24,26,28,29,30	//SEG16-SEG30
};
//LCDʵֻSEG0SEG15,SEG16,SEG18,SEG20,ʹ
//.hļVK1072b_SEGNUM=12
//const unsigned char vk1072b_segtab[VK1072b_SEGNUM]={
//	0,2,4,6,8,10,12,14,15,			//SEG0-SEG15
//	16,18,20,										//SEG16,SEG18,SEG20,
//};
//vk1072b_dispramӦоƬʾRAM
unsigned char vk1072b_dispram[VK1072b_SEGNUM];
//Ӧvk1072b_segtab[VK1072b_SEGNUM]
//ʾRAM bufferֻʹõ4λbit0->com0,bit1->com1,bit2->com2,bit3->com3
//LCD ʵ  38
//1ǰλ2ʮλ3Ǹλ
/*ʾbufferlcdͼӳϵ
vk1072b_dispram[VK1072b_SEGNUM]=
{//com3   com2   com1     com0 //ӦоƬSEG  ӦʾRAM
	1D,     1E,    1F,      1A,     //seg0   			vk1072b_dispram[0]
	  ,     1C,    1G,      1B,     //seg2				vk1072b_dispram[1]
	2D,     2E,    2F,      2A,     //seg12				vk1072b_dispram[6]	
	  ,     2C,    2G,      2B,     //seg14				vk1072b_dispram[7]
	3D,     3E,    3F,      3A,		  //seg16				vk1072b_dispram[9]
	  ,     3C,    3G,      3B,			//seg18				vk1072b_dispram[10]
}
*/
/*8ֵ 
     A
   F   B
     G
	 E   C
	   D
*/
unsigned char shuzi_zimo[15]= //ַֺģ
{
//0    1    2    3    4    5    6    7    8    9    -    L    o    H    i 
	0xF5,0x05,0xD3,0x97,0x27,0xB6,0xF6,0x15,0xF7,0xB7,0x02,0xE0,0xC6,0x67,0x05
};
unsigned char vk1072b_addrbit=6;//icramַA5-A0,
unsigned char vk1072b_segi,vk1072b_comi;
unsigned char vk1072b_maxcom;//com4com3com2com
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nms(unsigned long int n)
{
	while(n--)
	{
		delay_nus(1000);
	}
}
/*******************************************************************************
* Function Name  : WriteClock
* Description    : WRʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WriteClockVk1072b(void)
{
	VK1072b_WR_L(); 
	delay_nus(VK1072b_CLK);
	VK1072b_WR_H();	
	delay_nus(VK1072b_CLK);	
}
/*******************************************************************************
* Function Name  : WriteCommand
* Description    : д
* Input          : FunctonCode->/ 
* Output         : None
* Return         : None
*******************************************************************************/
void WriteCommandVk1072b(unsigned char FunctonCode)
{
	unsigned char Shift = 0x80; 
	unsigned char i;
	
	VK1072b_CS_L();   //CS Ƭѡ   
	delay_nus(VK1072b_CLK/2);
	VK1072b_DATA_H();  
	WriteClockVk1072b();
	VK1072b_DATA_L();  
	WriteClockVk1072b();
	VK1072b_DATA_L();  
	WriteClockVk1072b();

	for(i = 0; i < 8; i++) 
	{
	 if(Shift & FunctonCode) 	
		 VK1072b_DATA_H(); 
	 else 
		 VK1072b_DATA_L();	  

	 WriteClockVk1072b();
	 Shift = Shift >> 1;
	}
  VK1072b_DATA_L(); 
	WriteClockVk1072b();	//һ0һλ X
  VK1072b_CS_H(); 			//CS Ƭѡ  
	delay_nus(VK1072b_CLK/2);
  VK1072b_DATA_H(); 
}

/*******************************************************************************
* Function Name  : Write1Data
* Description    : д1SEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramĵַ  
* 							 : Databuf->дram(1ֽݵ4λЧ)  
* Output         : None
* Return         : None
*******************************************************************************/
void Write1DataVk1072b(unsigned char Addr,unsigned char Dat)
{
	unsigned char i; 
	unsigned char Shift;
	
	Shift = 0x20; //θ3λ ֻ5λ
	
	VK1072b_CS_L();  //CS Ƭѡ
	delay_nus(VK1072b_CLK/2);

	VK1072b_DATA_H();  
	WriteClockVk1072b();  //101
	VK1072b_DATA_L();  
	WriteClockVk1072b();
	VK1072b_DATA_H();  
	WriteClockVk1072b();

	for( i = 0; i < vk1072b_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VK1072b_DATA_H(); 		
		else  
			VK1072b_DATA_L();
		WriteClockVk1072b();		
		Shift = Shift >> 1; 
	}
  Shift = 0x01;
  for (i = 0; i < 4; i++) 
	{

		if( Dat & Shift) 
			VK1072b_DATA_H();		 
   	else  
			VK1072b_DATA_L();
		WriteClockVk1072b();
		Shift = Shift << 1;
	}   
  VK1072b_CS_H(); //CS Ƭѡ
	delay_nus(VK1072b_CLK/2);	
  VK1072b_DATA_H(); 
}
/*******************************************************************************
* Function Name  : WritenData
* Description    : дnSEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramʼַ  
* 							 : Databuf->дramָ(ÿֽݵ4λЧ)  
* 							 : Cnt->дramݸ
* Output         : None
* Return         : None
*******************************************************************************/
void WritenDataVk1072b(unsigned char Addr,unsigned char *Databuf,unsigned char Cnt)
{
	unsigned char i,j; 
	unsigned char Shift;
	unsigned char dataval; 
	
	VK1072b_CS_L();   //CS Ƭѡ 
	delay_nus(VK1072b_CLK/2);

	VK1072b_DATA_H();  
	WriteClockVk1072b();  //101
	VK1072b_DATA_L();  
	WriteClockVk1072b();
	VK1072b_DATA_H();  
	WriteClockVk1072b();

	Shift = 0x20;
	for( i = 0; i < vk1072b_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VK1072b_DATA_H(); 		
		else  
			VK1072b_DATA_L();
		WriteClockVk1072b();		
		Shift = Shift >> 1; 
	}
	for (j = 0; j < Cnt; j++) 
	{
		Shift = 0x01;
		dataval=*Databuf++;
		for (i = 0; i < 4; i++) 
		{
			if( dataval & Shift) 
				VK1072b_DATA_H();		 
			else  
				VK1072b_DATA_L();
			WriteClockVk1072b();
			Shift = Shift << 1;
		}   
	}
  VK1072b_CS_H();   //CS Ƭѡ
	delay_nus(VK1072b_CLK/2);	 
  VK1072b_DATA_H(); 
}
/*******************************************************************************
* Function Name  : Vk1072b_DisAll
* Description    : SEGʾͬһݣbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* 					     : 磺0x0fȫ 0x00ȫ 0x05 0x0a 0x03 
* Input          dat->дram(1ֽݵ4λЧ)  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072b_DisAll(unsigned char dat)
{
	unsigned char segi;
	unsigned char dispram[32];
	
	for(segi=0;segi<32;segi++)
	{
		dispram[segi]=0x00;
	}
	for(segi=0;segi<31;segi+=2)
	{
		dispram[segi]=dat;
	}
	dispram[15]=dat;
	dispram[29]=dat;
	WritenDataVk1072b(0,dispram,32);//4bitַԶ1
}
/*******************************************************************************
* Function Name  : DisSegComOn
* Description    : 1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072b_DisSegComOn(unsigned char seg,unsigned char com)
{
		Write1DataVk1072b(seg,(1<<com));
}
/*******************************************************************************
* Function Name  : DisSegComOff
* Description    : ر1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072b_DisSegComOff(unsigned char seg,unsigned char com)
{
		Write1DataVk1072b(seg,~(1<<com));
}
/*******************************************************************************
* Function Name  : Enter_Standby
* Description    : ͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072b_Enter_Standby(void)
{	
	//ʹLCDOFFSYSDIS,ϵͳڵ͹״̬
	//ֻʹƬRCʱԴʱ,ʹϵͳ͹״̬
	WriteCommandVk1072b(OSC_OFF);
	WriteCommandVk1072b(DISP_OFF);
}
/*******************************************************************************
* Function Name  : Exit_Standby
* Description    : ˳͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072b_Exit_Standby(void)
{	
	//˳͹״̬vk1072b
	WriteCommandVk1072b(OSC_ON);
	WriteCommandVk1072b(DISP_ON);
	WriteCommandVk1072b(COM_1_3__4);vk1072b_maxcom=4;	//1/3bias 4com
//	WriteCommandVk1072b(COM_1_3__3);vk1072b_maxcom=3;	//1/3bias 3com
//	WriteCommandVk1072b(COM_1_3__2);vk1072b_maxcom=2;	//1/3bias 2com
//	WriteCommandVk1072b(COM_1_2__4);vk1072b_maxcom=4;	//1/2bias 4com
//	WriteCommandVk1072b(COM_1_2__3);vk1072b_maxcom=3;	//1/2bias 3com
//	WriteCommandVk1072b(COM_1_2__2);vk1072b_maxcom=2;	//1/2bias 2com
}
/*******************************************************************************
* Function Name  : Lowlevel_Init
* Description    : ͨGPIO
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072b_Lowlevel_Init(void)
{
	//ͨߵƽͬӵƽת·
	//˺ݿͻƬӦ޸	
	GPIO_SetMode(VK1072b_CS_PORT, VK1072b_CS_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1072b_WR_PORT, VK1072b_WR_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1072b_DAT_PORT, VK1072b_DAT_PIN, GPIO_MODE_OUTPUT);	//ֻʾݿΪIO
		
	VK1072b_CS_H();                 
	VK1072b_WR_H();  
	VK1072b_DATA_H(); 	
}
/*******************************************************************************
* Function Name  : Init
* Description    : ʼ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072b_Init(void)
{	
	//ܽøݿͻƬӦ޸
	Vk1072b_Lowlevel_Init();
	//
	WriteCommandVk1072b(OSC_ON);
	WriteCommandVk1072b(DISP_ON);
	WriteCommandVk1072b(COM_1_3__4);vk1072b_maxcom=4;	//1/3bias 4com
//	WriteCommandVk1072b(COM_1_3__3);vk1072b_maxcom=3;	//1/3bias 3com com2/com1/com0
//	WriteCommandVk1072b(COM_1_3__2);vk1072b_maxcom=2;	//1/3bias 2com com1/com0
//	WriteCommandVk1072b(COM_1_2__4);vk1072b_maxcom=4;	//1/2bias 4com
//	WriteCommandVk1072b(COM_1_2__3);vk1072b_maxcom=3;	//1/2bias 3com com2/com1/com0
//	WriteCommandVk1072b(COM_1_2__2);vk1072b_maxcom=2;	//1/2bias 2com com1/com0
	//ϵĬ(δùܹرս͹)
//	WriteCommandVk1072b(BUZZ_2KHZ);
//	WriteCommandVk1072b(BUZZ_4KHZ);
//	WriteCommandVk1072b(BUZZ_ON);
	WriteCommandVk1072b(BUZZ_OFF);
	WriteCommandVk1072b(IRQ_DIS);
	WriteCommandVk1072b(TIMER_DIS);
	WriteCommandVk1072b(WDT_DIS);
}
/*******************************************************************************
* Function Name  : disp_3num
* Description    : ʾ3λ
* Input          dat->3λ ʮ 
* Output         : None
* Return         : None
*******************************************************************************/
void disp_3num(unsigned int dat)
{		
	unsigned dat8;
	
	dat8=dat/100%10;	//ʾλ
	vk1072b_dispram[0]=shuzi_zimo[dat8]>>4;
	vk1072b_dispram[1]&=0xf8;
	vk1072b_dispram[1]|=shuzi_zimo[dat8]&0x07;
	
	dat8=dat/10%10; 	//ʾʮλ
	vk1072b_dispram[6]=shuzi_zimo[dat8]>>4;
	vk1072b_dispram[7]&=0xf8;
	vk1072b_dispram[7]|=shuzi_zimo[dat8]&0x07;
	
	dat8=dat%10;			//ʾλ
	vk1072b_dispram[9]=shuzi_zimo[dat8]>>4;
	vk1072b_dispram[10]&=0xf8;
	vk1072b_dispram[10]|=shuzi_zimo[dat8]&0x07;
		
	if(dat<100)				//С100λʾ
	{
		vk1072b_dispram[0]&=0xf0;
		vk1072b_dispram[1]&=0xf8;
	}
	if(dat<10) 	//С10ʮλʾ
	{
		vk1072b_dispram[6]&=0xf0;
		vk1072b_dispram[7]&=0xf8;
	}
	//SEG11
	Write1DataVk1072b(0,vk1072b_dispram[0]);
	Write1DataVk1072b(2,vk1072b_dispram[1]);
	Write1DataVk1072b(12,vk1072b_dispram[6]);
	Write1DataVk1072b(14,vk1072b_dispram[7]);
	Write1DataVk1072b(16,vk1072b_dispram[9]);
	Write1DataVk1072b(18,vk1072b_dispram[10]);
	//SEGͶ
	
}	
/*******************************************************************************
* Function Name  : test_Main
* Description    : 
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072b_Main(void)
{	
	Vk1072b_Init();
	Vk1072b_DisAll(0x00);
	while(1)
	{
		Vk1072b_DisAll(0x0f);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk1072b_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		disp_3num(123);           //ʾ123
		delay_nms(3000);					//ʱ3S
		
		Vk1072b_DisAll(0x00);			//LCDȫ
		for(vk1072b_segi=0;vk1072b_segi<VK1072b_SEGNUM;vk1072b_segi++)//seg
		{
			for(vk1072b_comi=0;vk1072b_comi<vk1072b_maxcom;vk1072b_comi++)//com
			{
				Vk1072b_DisSegComOn(vk1072b_segtab[vk1072b_segi],vk1072b_comi);	//LCD
				delay_nms(300);				//ʱ300mS
				Vk1072b_DisAll(0x00);	//LCDȫ
			}
		}
		
		Vk1072b_DisAll(0x0f);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		for(vk1072b_segi=0;vk1072b_segi<VK1072b_SEGNUM;vk1072b_segi++)//seg
		{
			for(vk1072b_comi=0;vk1072b_comi<vk1072b_maxcom;vk1072b_comi++)//com
			{
				Vk1072b_DisSegComOff(vk1072b_segtab[vk1072b_segi],vk1072b_comi);	//LCDر
				delay_nms(300);				//ʱ300mS
				Vk1072b_DisAll(0x0f);	//LCDȫ
			}
		}
		delay_nms(1000);					//ʱ1S
		
		Vk1072b_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk1072b_Enter_Standby();		//͹ģʽ
		delay_nms(5000);					//ʱ5S
		
		Vk1072b_Exit_Standby();		//˳͹ģʽ
	}
}
/************************END OF FILE****/
